#include "buss.h"

using namespace std;

Buss::Buss() : Rute() {
    //lesData();
}

Buss::~Buss() {
}

void Buss::lesData() {
    int valg;
    // cout << "\nAntall sitteplasser: ";
    antallSitteplasser = lesInt("Antall sitteplasser", MIN_ANTALL_SITTEPLASSER,
                                MAX_ANTALL_SITTEPLASSER);
    antallStaplasser = lesInt("Antall ståplasser", MIN_ANTALL_STAPLASSER,
                              MAX_ANTALL_STAPLASSER);
    do {
        valg = lesChar("Leddbuss (J/n)");
    } while (valg != 'J' && valg != 'N');

    if (valg == 'J')
        leddbuss = true;
    else
        leddbuss = false;
}

void Buss::skrivData() {
    cout << "\n\t..::Buss info::.." << '\n';
    cout << "\tAntall sitteplasser: " << antallSitteplasser << '\n'
         << "\tAntall ståplasser:" << antallStaplasser << '\n'
         << "\tEr leddbuss: ";
    if (leddbuss)
        cout << "Ja";
    else
        cout << "Nei";
    cout << '\n';
}

void Buss::skrivType() {
    std::cout << "Buss";
}

void Buss::skrivDataForlengs() { 
    skrivData();
    Rute::skrivDataForlengs();
    cout << "\n\n";
}

void Buss::skrivDataBaklengs() {
    skrivData();    
    Rute::skrivDataBaklengs();
    cout << "\n\n";
}

void Buss::lesFraFil(ifstream& inn) {
    int i = 0;
    string heleLinjen = "";
    getline(inn, heleLinjen);
    vector<string> linjenSplittet = hjelp.splittStreng('*', heleLinjen);    
    for (const auto& val : linjenSplittet) {
        switch (i) {
            case 0:
                antallSitteplasser = stoi(val);
                break;
            case 1:
                antallStaplasser = stoi(val);
                break;
            case 2:
                leddbuss = stoi(val);
                break;
        }
        i++;
    }
    // inn >> antallSitteplasser >> antallStaplasser >> leddbuss;
    Rute::lesFraFil(inn);
}

void Buss::skrivTilFil(ofstream& ut) {
    ut << "Buss" << '\n';    
    ut << antallSitteplasser << '*'
       << antallStaplasser << '*'
       << leddbuss << '*'
       << '\n';
       Rute::skrivTilFil(ut);
}